/* Copyright (C) 1999 Jeff Heflin - University of Maryland

   This software is provided under the terms of the GNU General Public
   License Version 2, June 1991. See the file License.html for details.
*/

package Expose;

import java.awt.*;
import java.awt.event.*;
import java.util.Vector;

/** This is frame that allows the user to add values to a URL constraint
  list. */
public class ConstraintAdder extends Frame
                             implements ActionListener
{
  List conList;
  Vector conValues;
  TextField conField;
  Button b_Add;
  Button b_Close;

  public ConstraintAdder(List conList, Vector conValues) {

    super("URL Constraint Adder");
    this.conList = conList;
    this.conValues = conValues;

    Panel textPanel = new Panel();
    textPanel.setLayout(new GridLayout(2, 1));
    textPanel.add(new Label("New Constraint:"));
    conField = new TextField(40);
    conField.setBackground(Color.white);
    textPanel.add(conField);
    add("Center", textPanel);
    Panel butPanel = new Panel();
    b_Add = new Button("Add");
    b_Close = new Button("Close");
    butPanel.add(b_Add);
    butPanel.add(b_Close);
    b_Add.addActionListener(this);
    b_Close.addActionListener(this);

    add("South", butPanel);
    setBackground(Color.lightGray);
    setForeground(Color.black);
    pack();
    resize(minimumSize());
  }

  public void actionPerformed(ActionEvent event) {

    Object source = event.getSource();
    
    /* start a new search from URL entered in text box */
    if (source == b_Add) {
      String newCon = conField.getText();
      if (newCon.equals("") == false) {
	conValues.addElement(newCon);
	conList.add(newCon);
	conField.setText("");           // clear out entry box
      }
      // else
      //  setStatus("Enter a new URL prefix before pressing this button");
    }
    else if (source == b_Close) {
      dispose();
    }
  }

}
