package ShoeMsAccess;

/**
 * <p>Title: AccessKb</p>
 * <p>Description: Access version of ShoeKb</p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company:Lehigh University</p>
 * @author zpan
 * @version 1.0

 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * Author:  Zhengxiang Pan
 * Contact: Zhengxiang Pan (zhp2@lehigh.edu)
 *
 */

 //import java.sql.*;
import java.sql.Connection;
import java.sql.Statement;
import java.sql.SQLException;
import java.util.*;
import java.io.*;
import SHOE.*;
import ShoeKb.*;

public class AccessKb extends ShoeKb{
  /*global variables*/
  Connection con;
  Statement stmt;
  java.sql.ResultSet rs;
  //String kbName;
  //FileWriter flog;

  /**Constructor*/
  public AccessKb(KBInterface kb, OntManager ontman, PrintStream logOut,
		boolean implicitClaims)
  {
  super(kb, ontman, logOut,
		implicitClaims);
  }

   /** open the database*/
   public void openKB(String KbName)
       throws KBException
  {

     try{
     Class.forName("sun.jdbc.odbc.JdbcOdbcDriver");
        }
    catch(java.lang.ClassNotFoundException e)
                {
			System.out.print("ClassNotFoundException: ");
			System.out.println(e.getMessage());
                  }

      try{
          String s_open = "jdbc:odbc:MS Access Database;DBQ="+KbName;
          con = java.sql.DriverManager.getConnection(s_open,"","");
        }
        catch(SQLException e)
		{	System.out.println("error");
			while (e!=null)
			{	System.out.println("SQLState:"+e.getSQLState());
				System.out.println("Message :"+e.getMessage());
				System.out.println("Vendor  :"+e.getErrorCode());
				e=e.getNextException();
				System.out.println(" ");

                        }

                  } //not throw KBException now
    try
    {

    stmt = con.createStatement();
    }
    catch(SQLException e)
		{	System.out.println("error_in_stmt");
                }

     /*   try{
     flog = new FileWriter("d:\\flog.txt",false);
          }
     catch (java.io.IOException ioe)
     {
     System.out.println("open file error");
     }
      if(flog==null)
      System.out.println("open file failed");*/

    }



   /** Returns an array consisting of the OntDescriptors of every
    ontology known to the KB. */
  /* NOTE: consider returning the ontologies in a particular order,
     e.g., order of discovery, alpahabetical, etc. */
  public OntDescriptor[] getKnownOntologies() {

    OntDescriptor[] knownOnts = null;
    OntDescriptor   ontDesc;

    int seqnum = 12345;
    String id, ver,url;

    int i=0;

    String s = "SELECT * \nFROM Ontologies";

    try
    {
      rs = stmt.executeQuery(s);
      while (rs.next())
      {i++;}
      //System.out.println(i);
      knownOnts = new OntDescriptor[i];
      rs.close();

      rs = stmt.executeQuery(s);
      i=0;

      while (rs.next())
      {
        id = rs.getString("Id");
        ver = rs.getString("Version");
        url = rs.getString("Url");
        ontDesc = new OntDescriptor(id,ver,url,seqnum);
        knownOnts[i] = ontDesc;
        i++;
      }
    }
    catch (SQLException e)
      {
      System.out.println("error when get known ont");
      System.out.println(e.getMessage());
      }
    return knownOnts;
  }


  /** Closes the current knowledge base. */
  public void closeKB()
  {
  try{
  stmt.close();
  con.close();}
   catch(SQLException e)
		{	System.out.println("error");
                  }

     /*  try{

     flog.close();
     }
     catch (java.io.IOException ioe)
     {
     }*/
  }


  /** Given an instance and the URL of the page on which it resides,
     stores the claims made by the page in the KB. If the implicitClaims
     variable is set, it also makes any claims implied by the instance.
     If the instance requires any ontologies that are not currently
     cataloged in the KB, it will store these ontologies in the KB first. */
  /* BUG: Currently, we use the sourceUrl as the claimant. However,
     the SHOE spec considers the instance key as the claimant.
     The problem with that approach is then we have no way of
     knowing which document the claim came from and thus could not
     properly determine which claims to remove when a document is
     re-processed. Eventually, we need an extra predicate to indicate
     the source document of the claim, so that we can use the claims()
     predicate as it was intended. */

  public void storeNewOntologies(Use_Ontology[] useonts)
              //throws SQLException
  {

    String key;
    Use_Ontology uont;
    Ontology ont;

    for (int i=0; i < useonts.length; i++) {
      uont = useonts[i];
      key = Ontology.makeKey(uont.getId(), uont.getVersion());
      /* if this ontology is not in our hashtable, store it in the KB and
	 add it to the table */

      String s1 = "SELECT ontKey FROM Ontologies"+"\n WHERE ontKey ='";
      StringBuffer sb = new StringBuffer(s1);
      sb.append(key).append("'");
      String s = sb.toString();
      System.out.println(s);
      rs = null;
      int errorcode = 0;
      try{
      rs = stmt.executeQuery(s);
      }
      catch(SQLException e)
		{	System.out.println("error");
                        System.out.println("SQLState:"+e.getSQLState());
			System.out.println("Message :"+e.getMessage());
			System.out.println("Vendor  :"+e.getErrorCode());
                        errorcode = e.getErrorCode();
                }


        if (errorcode==-1305)
        {
          createKB();
        }


      boolean find_ont=false;
      if (rs!=null)
      {
        try{
        find_ont=rs.next();
        }
        catch(SQLException e)
		{	System.out.println("error");
                }
      }

       if(find_ont==false)
       {
	System.out.println("new ont found!");
        ont = ontman.getOntology(uont);
	if (ont != null) {
	  /* storeOntology() will add a catalog entry for the ontology */
	  storeOntology(ont);
	}
      }
    }
  }

  /*create ontologies table for KB*/
  void createKB()
  {
    try{
          stmt.executeUpdate("CREATE TABLE Ontologies ("+
                              "ontKey VARCHAR (100),"+
                              "Id VARCHAR(100),"+
                              "Version VARCHAR(100),"+
                              "Url VARCHAR(100),"+
                              "PRIMARY KEY (ontKey)"+
                              ")");
              }
              catch(SQLException e)
              {
                System.out.println("error when creat table 'Ontologies'");
                System.out.println("SQLState:"+e.getSQLState());
			System.out.println("Message :"+e.getMessage());
			System.out.println("Vendor  :"+e.getErrorCode());

              }
  }







  /** Issues an arbitrary query to the KB using the default
    ontology. Variables arguments are preceded by question marks. The
    answers are returned in a matrix. */
 public ResultSet issueQuery(Query query) {

    Query kbQuery;
    ResultSet rset = null;

    //kbQuery = toKbQuery(query);
    //rset = kb.queryKB(kbQuery);
    int i,j,ptype=0;
    Vector a = query.getAtoms();
    int l = a.size();
    String lastarg1="",lastarg2="",lastpre="",catfor="",catname="";
    StringBuffer colname = new StringBuffer("SELECT ");
    StringBuffer tablename = new StringBuffer("FROM ");
    StringBuffer condition = new StringBuffer("WHERE ");
    int hasname=0;
    int colnum = 0;
    Vector vcol = new Vector();
    vcol.clear();

    Vector tables = new Vector();
    tables.clear();

    Vector columns = new Vector();//new for alias
    columns.clear(); //--
    boolean same_colname = false;
    String unselected_var,unselected_colname,unselected_table1,unselected_table2,unselected_condition;


    for(i=0;i<l;i++)
    {
      ptype=0;
      Atom am = (Atom) a.get(i);
      String sp = am.toString();
      System.out.println(sp);

      String amp = am.getPredicate();
      String[] ama = am.getArguments();
      if(amp.startsWith("@every"))
      ptype=1;
      if(amp.startsWith("@string"))
      ptype=2;
      switch(ptype)
      {
      case 1: tablename.append(getTableName(ama[0])).append("_view, ");
              colname.append(getTableName(ama[0])).append("_view.for, ");
              columns.add("for");//new for alias
              vcol.add(ama[1]);
              catfor = ama[1];
              catname = ama[0];
      break;
      case 2:
              if(lastarg2==ama[0])
              {
               condition.append(getTableName(lastpre));
               condition.append(".arg2 LIKE '").append(ama[1]).append("' AND ");
              }
      break;
      default:

                if(!tables.contains(getTableName(amp)))
                {
                  tablename.append(getTableName(amp)).append(", ");
                  tables.add(getTableName(amp));
                }
                if(ama[1].startsWith("?"))
                {
                  if(catfor==ama[1])
                  {
                  String select_column_name = getTableName(amp)+".arg1";

                  colname.append(select_column_name).append(", ");
                  columns.add(select_column_name);

                  vcol.add(ama[0]);
                  }
                  else
                  {
                    String select_column_name = getTableName(amp)+".arg2";

                    if(!columns.contains(select_column_name))
                    {
                    colname.append(select_column_name).append(", ");
                    columns.add(select_column_name);
                    vcol.add(ama[1]);
                    }
                    else
                    {
                      colname.append(getTableName(amp)).append("_view.arg2, ");
                      tablename.append(getTableName(amp)).append("_view, ");
                      tables.add(getTableName(amp)+"_view");
                      same_colname = true;

                      vcol.add(ama[1]);


                     }

                    }
                 }

              if(catfor==ama[0])
              {
                if(same_colname==false)
                {
                  condition.append(getTableName(catname)).append("_view.for=");
                  condition.append(getTableName(amp)).append(".arg1 AND ");
                }
                else
                {
                  condition.append(getTableName(catname)).append("_view.for=");
                  condition.append(getTableName(amp)).append("_view.arg1 AND ");
                }

              }

              if(catfor==ama[1])
              {
                 condition.append(getTableName(catname)).append("_view.for=");
                 condition.append(getTableName(amp)).append(".arg2 AND ");
              }

              if(!ama[1].startsWith("?"))//is argument a variable?
              condition.append(getTableName(amp)).append(".arg2='").append(ama[1]).append("' AND ");
              else
              {
                  if((lastarg2==ama[0])&(ama[0]!=catfor))
                  {
                    if(same_colname==false)
                    {
                    condition.append(getTableName(lastpre)).append(".arg2=");
                    condition.append(getTableName(amp)).append(".arg1 ").append(" AND ");
                    }
                    else
                    {
                       condition.append(getTableName(lastpre)).append(".arg2=");
                       condition.append(getTableName(amp)).append("_view.arg1 ").append(" AND ");

                    }
                  }
                  if((lastarg1==ama[0])&(ama[0]!=catfor))
                  {
                      if(same_colname==false)
                      {
                        condition.append(getTableName(lastpre)).append(".arg1=");
                        condition.append(getTableName(amp)).append(".arg1 ").append(" AND ");
                      }
                      else
                      {
                        condition.append(getTableName(lastpre)).append(".arg1=");
                        condition.append(getTableName(amp)).append("_view.arg1 ").append(" AND ");
                      }
                  }

            }
      lastarg2 = ama[1];
      lastarg1 = ama[0];
      lastpre = amp;
      }


    }

    int len = colname.length();
    colname.delete(len-2,len);
    colname.append("\n");

    len = tablename.length();
    tablename.delete(len-2,len);
    tablename.append("\n");

    len = condition.length();
    condition.delete(len-4,len);
    condition.append("\n");

    String colnames = colname.toString();
    String tablenames = tablename.toString();
    String conditions = condition.toString();

    if(conditions.length()>6)
    System.out.println(colnames+tablenames+conditions);
    else
    System.out.println(colnames+tablenames);

    colnum = vcol.size();
    String[] varnames = new String[vcol.size()];
    for(i=0;i<colnum;i++)
    varnames[i] = (String) vcol.elementAt(i);

    rset = new ResultSet(varnames);


    try
    {
    if(conditions.length()>6)
    rs = stmt.executeQuery(colnames+tablenames+conditions);
    else
    rs = stmt.executeQuery(colnames+tablenames);
    while(rs.next())
    {
      String[] data = new String[colnum];
      for(i=0;i<colnum;i++)
      {
        data[i] = rs.getString(i+1);

      }

      rset.addResult(data);
    }

    rs.close();
    }
     catch(SQLException e)
		{	System.out.println("error when do query");
                        System.out.println(e.getMessage());
                }




    return rset;
  }

  /**return table name when do update
   *
   */
  private String getTableName(String ontId, String ontVer, String name)
  {

    StringBuffer cname = new StringBuffer(ontId);

    int end = cname.length();
    int begin = ontId.lastIndexOf("ont");
    if ((end-begin)==8)
    cname.delete(end-8,end);
    else
    cname.delete(end-3,end);

    cname.append("v_");
    String ov = ontVer;
    String ov2 = ov.replace('.','_');
    cname.append(ov2).append("_").append(name);
    String tn = cname.toString();
    String tn2 = tn.replace('-','_');

    return tn2;
  }

   /**return the exact table name when do query
    *
    */
   private String getTableName(String name)
  {
    Ontology actual_ont;
    Unique_Elt rootElmtId;
    String ontId, ontVer;

    actual_ont = ontman.getOntology(super.getdefaultOntId(), super.getdefaultOntVer());

    try {
	rootElmtId = ontman.resolveName(name, actual_ont);
      } catch (SHOEException ex) {
	System.err.println(ex.getMessage());
        return getTableName(super.getdefaultOntId(),super.getdefaultOntVer(),name);
      }

    ontId = rootElmtId.getOntId();
    ontVer = rootElmtId.getOntVer();
    return getTableName(ontId, ontVer, name);


  }

  /* ********************* Protected Methods ************************* */
  /** add new ontology's info into ontologies catalog*/
  protected void addToOntCatalog(Ontology ont)
  {
    String key;                  // ontology's key
    OntDescriptor ontDesc;

    key = ont.getKey();
    maxSeqNum = maxSeqNum + 1;
    ontDesc = new OntDescriptor(ont.getId(), ont.getVersion(), ont.getURL(),
				maxSeqNum);

    /* update stored onts for reference later in this session */
    StringBuffer sb = new StringBuffer();
    sb.append("INSERT INTO Ontologies VALUES ( '").append(key).append("', '");
    sb.append(ont.getId()).append("', '").append(ont.getVersion()).append("', '").append(ont.getURL()).append("' )");
    String s = sb.toString();
    System.out.println(s);
    try{
    stmt.executeUpdate(s);
    }
     catch(SQLException e)
		{	System.out.println("error when add new ont");
                }

  }






  /** Given a SHOE category and the URL of the page on which it resides,
    stores it in the knowledge base. */
  protected void storeCategory(Category cat, String sourceUrl) {

    String ocatname = cat.getElmtId().toString();
    String catname = ocatname.replace('-','_').replace(',','_').replace('.','_').replace(':','_');

    int begin = catname.indexOf("ont");

    StringBuffer cn = new StringBuffer(catname);
    if (catname.charAt(begin+3)!='o')
    cn.delete(begin,begin+4);
    else
    cn.delete(begin,begin+9);

    String catname2 = cn.toString();

    StringBuffer sb =new StringBuffer();
    sb.append("INSERT INTO ").append(catname2);
    sb.append(" VALUES ('");
    sb.append(cat.getForText()).append("','").append(sourceUrl);
    sb.append("')");
    String s = sb.toString();
    System.out.println(s);

    String r = null;

    try{
    stmt.executeUpdate(s);
      }
       catch(SQLException e)
		{	System.out.println("error when store cat");
                      System.out.println(e.getMessage());
                         r= e.getMessage();
                }

    /*try{
    flog.write(s);
    flog.write("\n");
     if(r!=null)
    flog.write(r);
    flog.write("\n");
    }
    catch (java.io.IOException ioe){
    }
        */
  }


  /** Given a SHOE DEF_CATEGORY and its source ontology, stores it in
    the KB. The isa links and names are stored. */
  protected void storeDefCategory(Def_Category dcat, Ontology ont) {

    String tablename = getTableName(ont.getId(),ont.getVersion(),dcat.getName());

    // name the table of this Category like "cs_dept_v1_0_catname"


    StringBuffer sb =new StringBuffer();
    sb.append("CREATE TABLE ");
    sb.append(tablename).append("(\n For VARCHAR (100), ");
    sb.append("\n Source VARCHAR (100), \n PRIMARY KEY (For) \n)");
    String s = sb.toString();
    String r = null;
    String r2 = null;

    StringBuffer sb2 = new StringBuffer();
    sb2.append("CREATE VIEW ").append(tablename).append("_view AS\n SELECT * FROM ");
    sb2.append(tablename);
    String s2 = sb2.toString();

    try{
    stmt.executeUpdate(s);
      }
       catch(SQLException e)
		{	System.out.println("error when stroe Def_Cat");
                       System.out.println("SQLState:"+e.getSQLState());
				System.out.println("Message :"+e.getMessage());
				System.out.println("Vendor  :"+e.getErrorCode());
                        r =e.getMessage();

                }


    try
      {
        stmt.executeUpdate(s2);
      }
      catch(SQLException e)
		{	System.out.println("error when first creat view for Def_Cat");
                       System.out.println("SQLState:"+e.getSQLState());
				System.out.println("Message :"+e.getMessage());
				System.out.println("Vendor  :"+e.getErrorCode());
                        r2 =e.getMessage();

                }

    /*try{

     flog.write(s);
     if(r!=null)
     flog.write(r);
     if(r2!=null)
     flog.write(r2);
      flog.write("\n");
     }
     catch (java.io.IOException ioe)
     {
     }*/

  }


  /** Given a SHOE DEF_CONSTANT and its source ontology, stores it in
    the KB. Only the instance links are stored. */
  protected void storeDefConstant(Def_Constant dconst, Ontology ont) {



  }


  /** Given a SHOE DEF_RELATION and its source ontology, stores it in
    the KB. A new predicate of the correct arity is created. */
  protected void storeDefRelation(Def_Relation drel, Ontology ont) {

    String objKbName;               // the KB specific name of a SHOE object
    String key;
    Def_Arg[] dargs;
    String[] argTypes;
    Unique_Elt argTypeId;

  //  key = ont.getKey();

    //objKbName = getUniqueName(ont, drel.getName());

    // kb.createPredicate(objKbName, drel.getArity());

    dargs = drel.getDefArgs();
    /*  argTypes = new String[dargs.length];
    for (int i=0; i<dargs.length; i++) {
      argTypeId = dargs[i].getTypeId();
      argTypes[i] = getUniqueName(argTypeId);
    }
    kb.createPredicate(objKbName, argTypes);*/

    String tablename = getTableName(ont.getId(),ont.getVersion(),drel.getName());


     StringBuffer sb= new StringBuffer();
     sb.append("CREATE TABLE ").append(tablename).append("(");
     for (int i=0; i<dargs.length; i++) {

     if (i!=0)
     sb.append(",");
     sb.append("\narg").append(i+1);

     switch(dargs[i].getTypeClass())
     {
     //case 1:
     //sb.append(" ").append("INTEGER").append(",");
     //break;
     default:
     sb.append(" ").append("VARCHAR").append(" (100)");
     }
     }

        sb.append(",\nPRIMARY KEY (");
        for (int i=0; i<dargs.length; i++)
              {
              if(i!=0)
              sb.append(",");
              sb.append("arg").append(i+1);
              }
        sb.append(")\n)");

      String s = sb.toString();
      String r = null;
     //System.out.println(s);
     //if(flog == null)
     //System.out.println("file null");




     try{
     stmt.executeUpdate(s);
     }
      catch(SQLException e)
		{	System.out.println("error when stroe Def_Rel");
                        r= e.getMessage();
                }




     if(tablename.equals("base_v_1_0_name"))
     {
      String qs = "CREATE VIEW base_v_1_0_name_view AS SELECT * FROM base_v_1_0_name";

          	try{
            		stmt.executeUpdate(qs);
          	}
         	 catch(SQLException e)
              	{
              		System.err.println("e.getMessage()");
              	}
     }
        /* try{
         flog.write(s);
        if(r!=null)
        flog.write(r);
        flog.write("\n");
     }
     catch (java.io.IOException ioe)
     {
     }*/

    }

    /* NOTE: Add code for infering types from relation arguments here! */



  /** Given a SHOE DEF-INFERENCE rule and its source ontology, asserts it
    the KB. */
  protected void storeInferenceRule(Def_Inference dinf, Ontology ont)
  {}


  /** Given a SHOE relation and the URL of the page on which it resides,
    stores it in the knowledge base. If the implicitClaims variable is
    set, it also tracks any claims implied by the relation. */
  protected void storeRelation(Relation rel, String sourceUrl,
			       Hashtable impCats)
  {
    RelArg argList[];
    String argVals[];
    int i;
    Unique_Elt ontRef;
    String predName;

    String orelname = rel.getElmtId().toString();
    String relname = orelname.replace('-','_').replace(',','_').replace('.','_').replace(':','_');

    int begin = relname.indexOf("ont");
    StringBuffer rn = new StringBuffer(relname);
    if (relname.charAt(begin+3)!='o')
    rn.delete(begin,begin+4);
    else
    rn.delete(begin,begin+9);

    String relname2 = rn.toString();


    StringBuffer sb = new StringBuffer();
    sb.append("INSERT INTO ").append(relname2).append(" VALUES (");

    if (rel.getElmtId() != null)
    {        // only store valid relations
      argList = rel.getArgs();

      /* Get an array of argument values. If the value is a reference to
	 an ontology object, use the unique name of the ontology object */
      argVals = new String[argList.length];
      for (i=0; i < argList.length; i++) {
	ontRef = argList[i].getOntReference();
	if (ontRef != null)
	  argVals[i] = getUniqueName(ontRef);
	else
	  argVals[i] = argList[i].getValue();

      if(i!=0)
      sb.append(",");
      sb.append("'").append(argVals[i]).append("'");

      }
      sb.append(" )");
     }

    String s = sb.toString();
    System.out.println(s);

    String r = null;
    try{
    stmt.executeUpdate(s);
      }
       catch(SQLException e)
		{	System.out.println("error when store rel");
                         System.out.println(e.getMessage());
                        r= e.getMessage();
                }

   /*try{
    flog.write(s);
    flog.write("\n");
    if(r!=null)
    flog.write(r);
    flog.write("\n");
    }
    catch (java.io.IOException ioe){
    }*/
  }





  /* ********************* Private Methods ************************* */







  /* The next two methods are only used in non-axiomatic KBs that
     implement the semantics of typed relation arguments, i.e.,
     an instance that appears in a typed argument position can be
     inferred to be a member of that class. */


   /** Stores the ontology's DEF_CATEGORYs, DEF_RELATIONs and DEF_CONSTANTs
    in the KB. For DEF_CATEGORYs, the isa links and names are stored.
    For DEF_RELATIONs a new predicate of the correct arity is created.
    For DEF_CONSTANTs, only the instance links are stored. Stores
    catalog information about the ontology as well, including a
    sequence number assigned to it. */
  public void storeOntology(Ontology ont) {

    SHOE_Obj obj;
    Def_Category dcat,dcat2;
    Def_Relation drel;
    Def_Constant dconst;
    Def_Inference dinf;
    Vector   rules;
    Enumeration enum;

    // store any requisite ontologies that are unknown to the KB
    /* By calling storeNewOntologies before assigning a sequence
       number, the sequence numbers should be assigned first
       to those ontologies on which an ontology depends. */
    storeNewOntologies(ont.getUseOnts());

    //super.docMessages = super.docMessages + "Storing ontology " + ont.getOntLabel() + "\n";//?

    addToOntCatalog(ont);

    setBackwardCompatibility(ont);
    setExtendedOnts(ont);

    Vector categories = new Vector(); //zpan
    categories.clear();

    enum = ont.getElements();
    while (enum.hasMoreElements()) {
      obj = (SHOE_Obj)enum.nextElement();
      if (obj instanceof Def_Category) {
	dcat = (Def_Category)obj;
	storeDefCategory(dcat, ont);
        categories.add(dcat);   //zpan
      }
      else if (obj instanceof Def_Relation) {    	// create predicates
	drel = (Def_Relation)obj;
	storeDefRelation(drel, ont);
      }
      else if (obj instanceof Def_Constant) {
	dconst = (Def_Constant)obj;
	storeDefConstant(dconst, ont);
      }
    }

    rules = ont.getInferenceRules();
    enum = rules.elements();
    while (enum.hasMoreElements()) {
      dinf = (Def_Inference)enum.nextElement();
      storeInferenceRule(dinf, ont);
    }

    //zpan: create views for every categories
    int length = categories.size();
    for(int i=0;i<length;i++)
    {
      dcat2 = (Def_Category)categories.elementAt(i);
      System.out.println("?!");

      creatView(dcat2,ont);
      //System.out.println("creatView called");
    }
  }


  /**creat a view for giving category*/
  void creatView(Def_Category dcat, Ontology ont)
  {
    if(!dcat.getChildIds().hasMoreElements())
    {
    //System.out.println("return"); // for test
    //return;
    }
    else
    {
    //System.out.println("not return"); // for test
      String dv = "DROP TABLE "+getTableName(ont.getId(),ont.getVersion(),dcat.getName())+"_view";
      StringBuffer cvb = new StringBuffer("CREATE VIEW ");
      cvb.append(getTableName(ont.getId(),ont.getVersion(),dcat.getName())).append("_view");
      cvb.append(" AS\n SELECT * FROM ").append(getTableName(ont.getId(),ont.getVersion(),dcat.getName())).append("\nUNION ");

     Enumeration enum = dcat.getChildIds();
     while (enum.hasMoreElements())
      {
        Unique_Elt childId = (Unique_Elt)enum.nextElement();
        String vname = getTableName(childId.getOntId(),childId.getOntVer(),childId.getName())+"_view";
        cvb.append("SELECT * FROM ").append(vname).append("\nUNION ");
      }
      int len = cvb.length();
      cvb.delete(len-6,len);
      String cv = cvb.toString();
      String r= null,r2=null;
      try{
        stmt.executeUpdate(dv);

        }
       catch(SQLException e)
		{	System.out.println("error when adjust view for Def_Cat");
                        System.out.println("SQLState:"+e.getSQLState());
				System.out.println("Message :"+e.getMessage());
				System.out.println("Vendor  :"+e.getErrorCode());
                                r=e.getMessage();
                  }
       try{

        stmt.executeUpdate(cv);
        }
        catch(SQLException e)
		{	System.out.println("error when adjust view for Def_Cat");
                        System.out.println("SQLState:"+e.getSQLState());
				System.out.println("Message :"+e.getMessage());
				System.out.println("Vendor  :"+e.getErrorCode());
                                r2=e.getMessage();
                  }
        /*try{

        flog.write(dv);
        flog.write("\n");
        if(r!=null)
        flog.write(r);
        flog.write("\n");
        flog.write(cv);
        flog.write("\n");
        if(r2!=null)
        flog.write(r2);
        flog.write("\n");
          }
         catch (java.io.IOException ioe)
        {
         }*/

      }
    }

    /** Stores the SHOE information from the given document in the KB.
   Any claims originally stored for the source are deleted, and any
   new ontologies are loaded before the new claims are stored. */
  public void storeSHOEDoc(SHOE_Doc doc, String sourceUrl) {

    Enumeration enum;
    SHOE_Obj docContent;
    Instance inst;
    Date parseDate;

    // urlStr = vnode.url.toString();

    setdocMessages("");

    /* delete old assertions for this page before storing new ones. Also
     delete claims that were implied by the source (if any). */
    // System.out.println("Deleting existing claims for source");
    /* disable kbinterface  -Zpan
    kb.deleteClaims(sourceUrl);
    kb.deleteClaims(sourceUrl + "#implied");
    */
    // System.out.println("Deleted existing claims");

    /* examine claims made within the document */
    if (doc.getVersion() == 1.0) {
      doc.validate(ontman);
      enum = doc.getPSHOE();
      while (enum.hasMoreElements()){
	docContent = (SHOE_Obj)enum.nextElement();
	if (docContent instanceof Instance) {
	  inst = (Instance)docContent;
	  // storeInstance() will will first store any requisite ontologies
	  storeInstance(inst, sourceUrl);
	}
      }
    }
  }


  /** Establish a connection to the given host and port number. */
  public void establishConnection(String host, int port)
       throws KBException
  {

  }

  /** Closes the current connection. Any open KBs will be closed as well. */
  public void closeConnection()
  {

  }

  /**tables will be created during the storage process when it is required.
   * override createKb(kbName) in ShoeKb.java
   * currently there is no way to create a Access database using in this method.
   * so make sure the database with the kbName does exist.*/
  public void createKB(String kbName)
  {
    try{
    openKB(kbName);
    }
    catch (Exception e)
    {
      System.out.println("can't find database file");
    }
  }

}