package ShoeMsAccess;

/**
 * <p>Title: ExposeApp</p>
 * <p>Description: Implements Expose with MS Access as a backend knowledge base.</p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company: Lehigh University</p>
 * @author zhengxiang pan
 * @version 1.0

 * This software is provided under the terms of the GNU Lesser General Public
 * License Version 2.1, February 1999. See the header in AccessKb.java
 * and the file License.html for details.
 */

import ShoeKb.*;
import SHOE.OntManager;
import java.io.PrintStream;


public class ExposeApp extends Expose.ExposeApp
{

  public ExposeApp()
  {
    super();
  }

  public static void main(String[] args)
  {
    ExposeApp app = new ExposeApp();
  }

  /** Returns a KB interface suitable for editing an existing KB. This
      function can be overriden so that different backends can be
      used. */
  public KBInterface getInterfaceForEditKb() {

    System.out.println("Using Access for existing KB");
    return null;    // set to update KB dynamically
  }


  /** Returns a KB interface suitable for creating a new KB. This
      function can be overriden so that different backends can be
      used. */
  public KBInterface getInterfaceForNewKb() {

    System.out.println("Using Access for new KB");
    return null;    // set to create new KB file
  }

  /** Returns a ShoeKb object which allows standard SHOE operations to be
    excuted against an underlying knowledge base. This function can be
    overriden so that a subclass of ShoeKb with an alternate implementation
    can be returned. */
  public ShoeKb getShoeKb(KBInterface kb, OntManager ontman,
			  PrintStream logout)
  {
    /* Note it is important to pass the protected implicitClaims
       variable so that ShoeKb knows whether or not to track
       and add them. */
    return new AccessKb(kb, ontman, logout, false);
  }

}