package ShoeMsAccess;

/**
 * <p>Title: SHOELoader</p>
 * <p>Description: Access version of SHOELoader</p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company: Lehigh University</p>
 * @author Zhengxiang Pan
 * @version 1.0

 * This software is provided under the terms of the GNU Lesser General Public
 * License Version 2.1, February 1999. See the header in AccessKb.java
 * and the file License.html for details.
 */

import java.io.*;
import java.util.*;
import java.net.*;
import java.text.*;                // for formatting and parsing dates
import SHOE.*;
import ShoeKb.*;
import HTML.*;
import UserInt.Utilities;
import Expose.*;

/** An application that given a URL, fetches the corresponding web page
  and stores the information contained within a Parka knowledge base.

  USAGE:
  java Expose.SHOELoader url
  java Expose.SHOELoader url kbname host port
  */
public class SHOELoader extends Expose.SHOELoader
{
  /* Constants */
  public static String DEFAULT_KB = "d:\\Shoe.kb";
  public static String DEFAULT_HOST = "local";
 // public static int DEFAULT_PORT = 0;
 // public static String logFile = "loader.log";
  //public static boolean implicitClaims = true;


  //public static final int TABSIZE = 8;

  public static void main(String args[])
  {

    SHOELoader app;
    int portNum = DEFAULT_PORT;
    File file;
    if (args.length == 2)

      app = new SHOELoader(args[0],args[1]);
    else if (args.length == 3)
    {
      if (args[0].equals("-f"))
      {
        file = new File(args[1]);
        app = new SHOELoader(file, args[2]);
      }
    }
     // app = new SHOELoader(args[0], args[1], args[2], portNum);

    else {
      System.err.println("Usage: java Expose.SHOELoader url | -f file data_file_path [host port]");
      System.exit(1);
    }
    System.exit(0);
  }

  /** Constructor that causes the gathered data to be stored in the
    default knowledge base, located at the default host and port. */
  public SHOELoader(String startUrl,String kbName)
  {
    super(startUrl, kbName, DEFAULT_HOST, DEFAULT_PORT);
   // beginLoader(kbName, DEFAULT_HOST, DEFAULT_PORT);
   // processUrl(startUrl, kbName);

        /*if (DEFAULT_KB == null || DEFAULT_HOST == null) {
      System.err.println("Must set default KB, host and/or port in " +
			 "source code");
      System.exit(1);
    }*/
    //beginLoader(startUrl, kbName, DEFAULT_HOST, DEFAULT_PORT);
  }

  public SHOELoader(File file, String kbName)
  {
    super(file, kbName, DEFAULT_HOST, DEFAULT_PORT);
  }

  /** Initializes the object and begins processing of the specified
    web page. */
  protected void beginLoader(String kbName, String host, int port)
  {
    KBInterface baseKb;               // stores interface to knowledge base
    URL url = null;

  //  baseKb = new ParkaInterface();
    ontman = new OntManager();

    kb = new AccessKb(null, ontman,  System.out,
		implicitClaims);
    try {
         kb.openKB(kbName);
    } catch (Exception ex) {
      System.out.println(ex.toString());
      System.out.println("Exiting...");
      return;
    }

    /* date formatters (needed for printing log information) */
    dformat = DateFormat.getDateTimeInstance(DateFormat.SHORT, DateFormat.MEDIUM);
    dformat.setTimeZone(TimeZone.getDefault());
    httpDate = new SimpleDateFormat("EE, dd MMM yyyy HH:mm:ss z");
    TimeZone tz = TimeZone.getTimeZone("GMT");
    httpDate.setTimeZone(tz);
    // System.out.println("Date is " + httpDate.format(new Date()));

    /* create output stream for log */
    try {
      logOut = new PrintStream(new FileOutputStream(logFile, true));
    } catch (IOException ex) {
      System.out.println("Couldn't open log file " + logFile);
      exit(1);
    }
    //logOut.print(super.formatSearchDetail(startUrl)); //can not use private
    logOut.print("\t" + kbName);

  /*  try {
      url = new URL(startUrl);
    } catch (MalformedURLException ex) {
      logOut.println("\tINVALID URL");
      exit(1);
    }

    /*
    // put URL in cannonical format
    url = normalizeURL(url);
    */
   // internPage(url, kbName);

   // exit(0);
  }

}

