package UserInt;

import java.awt.*;

public class ArrayMenu extends Menu {
  /* Allows menus to be created by simply passing an array of labels.
     There are prefixing characters that alter the form of the menu item.
     '~' Disabled item
     '+' Enabled, selected checkbox item
     '#' Disabled, selected checkbox item
     '-' Enabled, unselected checkbox item
     '=' Disabled, unselected checkbox item
 */

  public ArrayMenu(Object labels[]) {
    super ((String)labels[0]);

    String menuName = (String) labels[0];
    char firstMenuChar = menuName.charAt(0);

    if (firstMenuChar == '~' || firstMenuChar == '!') {
      setLabel(menuName.substring(1));
      if (firstMenuChar == '~')
	disable();
    }
    for (int i=1; i < labels.length;++i) {
      if (labels[i] instanceof String) {
	if ("-".equals(labels[i]))
	  addSeparator();
	else {
	  String label = (String)labels[i];
	  char firstChar = label.charAt(0);
	  switch (firstChar) {
	  case '+':
	    CheckboxMenuItem checkboxItem = new CheckboxMenuItem(label.substring(1));
	    checkboxItem.setState(true);
	    add(checkboxItem);
	    break;
	  case '#':
	    checkboxItem = new CheckboxMenuItem(label.substring(1));
	    checkboxItem.setState(true);
	    checkboxItem.disable();
	    add(checkboxItem);
	    break;
	  case '-':
	    checkboxItem = new CheckboxMenuItem(label.substring(1));
	    checkboxItem.setState(false);
	    add(checkboxItem);
	    break;
	  case '=':
	    checkboxItem = new CheckboxMenuItem(label.substring(1));
	    checkboxItem.setState(false);
	    checkboxItem.disable();
	    add(checkboxItem);
	    break;
	  case '~':
	    MenuItem menuItem = new MenuItem(label.substring(1));
	    menuItem.disable();
	    add(menuItem);
	    break;
	  case '!':
	    add(label.substring(1));
	    break;
	  default:
	    add(label);
	  }
	}
      }
      else {
	add(new ArrayMenu((Object[])labels[i]));
      }
    }
  }
 
  public MenuItem getItem(String menuItem) {
    int numItems = countItems();
    for(int i=0; i < numItems; ++i)
      if (menuItem.equals(getItem(i).getLabel()))
	return getItem(i);
    return null;
  }
}

